Index: /trunk/src/org/expeditee/actions/Actions.java
===================================================================
--- /trunk/src/org/expeditee/actions/Actions.java	(revision 375)
+++ /trunk/src/org/expeditee/actions/Actions.java	(revision 376)
@@ -721,7 +721,8 @@
 		int ind = 0;
 
-		// if the first class in the list is a frame or item, it is the source
-		// or launcher
-		// length must be at least one if we are still running
+		/*
+		 * if the first class in the list is a frame or item, it is the source
+		 * or launcher length must be at least one if we are still running
+		 */
 		if (paramTypes[ind] == Frame.class) {
 			objects[ind] = source;
@@ -886,6 +887,8 @@
 			return PerformAction(current, launcher, command);
 		} catch (RuntimeException e) {
+			e.printStackTrace();
 			MessageBay.errorMessage("Action failed: " + e.getMessage());
 		} catch (Exception e) {
+			e.printStackTrace();
 			MessageBay.errorMessage("Action failed: "
 					+ e.getClass().getSimpleName());
Index: /trunk/src/org/expeditee/actions/GreenstoneActions.java
===================================================================
--- /trunk/src/org/expeditee/actions/GreenstoneActions.java	(revision 376)
+++ /trunk/src/org/expeditee/actions/GreenstoneActions.java	(revision 376)
@@ -0,0 +1,121 @@
+package org.expeditee.actions;
+
+import java.awt.Color;
+import java.lang.reflect.InvocationTargetException;
+import java.lang.reflect.Method;
+import java.util.Map;
+
+import org.expeditee.agents.SearchGreenstone;
+import org.expeditee.greenstone.ResultDocument;
+import org.expeditee.gui.AttributeValuePair;
+import org.expeditee.gui.MessageBay;
+
+public class GreenstoneActions {
+	public static void givePositiveFeedback(String text) {
+		giveFeedback(1, text);
+	}
+
+	public static void giveNegativeFeedback(String text) {
+		giveFeedback(-1, text);
+	}
+
+	public static void clearGreenstoneSession() {
+		SearchGreenstone.clearSession();
+	}
+
+	public static void giveFeedback(double change, String text) {
+		Map<String, ResultDocument> sessionResults = SearchGreenstone
+				.getConnection().getSessionResults();
+
+		if (sessionResults.size() == 0) {
+			MessageBay.errorMessage("The Greenstone Session is empty");
+			return;
+		}
+
+		for (String line : text.split("\n")) {
+			AttributeValuePair avp = new AttributeValuePair(line, false);
+
+			Method getMethod = null;
+			String targetValue = null;
+
+			if (!avp.hasPair()) {
+				if (!avp.hasAttributeOrValue())
+					continue;
+				/*
+				 * If only an attribute is supplied then search for it in the
+				 * entire biliographic text.
+				 * 
+				 */
+				try {
+					getMethod = ResultDocument.class.getMethod("toString",
+							new Class[] {});
+				} catch (SecurityException e) {
+					e.printStackTrace();
+				} catch (NoSuchMethodException e) {
+					e.printStackTrace();
+				}
+				targetValue = avp.getAttributeOrValue();
+			} else {
+				targetValue = avp.getValue().trim().toLowerCase();
+				String attribute = avp.getAttribute().trim().toLowerCase();
+
+				String methodName = "get"
+						+ Character.toUpperCase(attribute.charAt(0))
+						+ attribute.substring(1);
+
+				try {
+					getMethod = ResultDocument.class.getMethod(methodName,
+							new Class[] {});
+				} catch (SecurityException e) {
+					e.printStackTrace();
+					continue;
+				} catch (NoSuchMethodException e) {
+					// User provided an invalid attribute value pair
+					MessageBay.errorMessage("Invalid feedback characteristic: "
+							+ attribute);
+					continue;
+				}
+				
+				if(getMethod == null){
+					MessageBay.errorMessage("Document attribute does not exist: " + methodName);
+				}
+			}
+
+			for (ResultDocument srd : sessionResults.values()) {
+				double sessionScore = srd.getSessionScore();
+
+				/*
+				 * You will refine this part to make more sophisticated
+				 * comparisons and more sensible score modifications
+				 */
+
+				Object value = null;
+				try {
+					if(getMethod.getReturnType() == null){
+						//Get methods should always return a value
+						assert(false);
+					}
+					value = getMethod.invoke(srd, new Object[] {}).toString();
+				} catch (IllegalArgumentException e) {
+					e.printStackTrace();
+				} catch (IllegalAccessException e) {
+					e.printStackTrace();
+				} catch (InvocationTargetException e) {
+					e.printStackTrace();
+				}catch (NullPointerException e) {
+					e.printStackTrace();
+				}
+
+				if (value != null) {
+					if (value.toString().trim().toLowerCase().contains(targetValue)) {
+						sessionScore = sessionScore + change;
+					}
+
+					srd.setSessionScore(sessionScore);
+				}
+			}
+		}
+		MessageBay.displayMessage("Feedback complete", null, Color.green
+				.darker(), true, null);
+	}
+}
Index: /trunk/src/org/expeditee/actions/Misc.java
===================================================================
--- /trunk/src/org/expeditee/actions/Misc.java	(revision 375)
+++ /trunk/src/org/expeditee/actions/Misc.java	(revision 376)
@@ -17,5 +17,5 @@
 import javax.imageio.ImageIO;
 
-import org.expeditee.agents.wordprocessing.JSpellChecker;
+import org.expeditee.gui.AttributeUtils;
 import org.expeditee.gui.Browser;
 import org.expeditee.gui.DisplayIO;
@@ -35,5 +35,5 @@
 import org.expeditee.simple.SString;
 import org.expeditee.stats.CometStats;
-import org.expeditee.stats.DocumentStats;
+import org.expeditee.stats.DocumentStatsFast;
 import org.expeditee.stats.SessionStats;
 import org.expeditee.stats.StatsLogger;
@@ -274,12 +274,13 @@
 
 	}
-	
+
 	public static String GetDocumentStats(Frame frame) {
 		TimeKeeper timer = new TimeKeeper();
 		MessageBay.displayMessage("Computing document stats...");
-
-		DocumentStats docStats = new DocumentStats(frame);
+		FrameIO.ForceSaveFrame(frame);
+		DocumentStatsFast docStats = new DocumentStatsFast(frame.getName(),
+				frame.getTitle());
 		String result = docStats.toString();
-		
+
 		MessageBay.overwriteMessage("Document stats time: "
 				+ timer.getElapsedStringSeconds());
@@ -436,18 +437,27 @@
 	 * PNGFrame(currentFrame.getName())
 	 */
-	public static void PNGFrame() {
-		ImageFrame(DisplayIO.getCurrentFrame().getName(), "PNG");
+	public static void PNGFrame(Frame frame) {
+		ImageFrame(frame.getName(), "PNG");
 	}
 
 	public static String SaveImage(BufferedImage screen, String format,
 			String directory, String fileName) {
+		String suffix = "." + format.toLowerCase();
+		String shortFileName = fileName;
 		// Check if we need to append the suffix
 		if (fileName.indexOf('.') < 0)
-			fileName += "." + format.toLowerCase();
+			fileName += suffix;
+		else
+			shortFileName = fileName.substring(0, fileName.length() - suffix.length());
 
 		try {
+			int count = 2;
 			// set up the file for output
-			String fullFileName = directory + fileName;
-			File out = new File(fullFileName);
+			File out = new File(directory + fileName);
+			while (out.exists()) {
+				fileName = shortFileName + "_" + count++ + suffix;
+				out = new File(directory + fileName);
+			}
+
 			if (!out.getParentFile().exists())
 				out.mkdirs();
@@ -910,41 +920,37 @@
 	}
 
-	public static String checkSpelling(String word) {
-		try {
-			return JSpellChecker.getInstance().getSuggestions(word);
-		} catch (FileNotFoundException e) {
-			MessageBay.errorMessage("Could not find dictionary: "
-					+ e.getMessage());
-		} catch (IOException e) {
-			// TODO Auto-generated catch block
-			e.printStackTrace();
-		}
-		return null;
-	}
-	
-	public static String spellCheck(String word) {
-		return checkSpelling(word);
-	}
-	
 	public static int wordCount(String paragraph) {
 		return paragraph.trim().split("\\s+").length + 1;
 	}
-	
+
 	public static int wordCount(Frame frame) {
 		int count = 0;
-		
-		for(Text t: frame.getBodyTextItems(false)){
+
+		for (Text t : frame.getBodyTextItems(false)) {
 			count += wordCount(t.getText());
 		}
-		
+
 		return count;
 	}
-	
-	public static void moveToPublic(Frame frame){
+
+	public static void moveToPublic(Frame frame) {
 		FrameIO.moveFrameset(frame.getFramesetName(), FrameIO.PUBLIC_PATH);
 	}
-	
-	public static void moveToPrivate(Frame frame){
+
+	public static void moveToPrivate(Frame frame) {
 		FrameIO.moveFrameset(frame.getFramesetName(), FrameIO.FRAME_PATH);
 	}
+
+	/**
+	 * Returns the value of a specified item attribute.
+	 * 
+	 * @param item
+	 *            from which to extract the value
+	 * @param attribute
+	 *            name of an items attribute
+	 * @return the value of the attribute
+	 */
+	public static String extract(Item item, String attribute) {
+		return AttributeUtils.getAttribute(item, attribute);
+	}
 }
Index: /trunk/src/org/expeditee/actions/Simple.java
===================================================================
--- /trunk/src/org/expeditee/actions/Simple.java	(revision 375)
+++ /trunk/src/org/expeditee/actions/Simple.java	(revision 376)
@@ -20,8 +20,8 @@
 import org.expeditee.agents.DisplayTree;
 import org.expeditee.agents.SearchAgent;
+import org.expeditee.agents.SearchFramesetAndReplace;
 import org.expeditee.agents.SearchFrameset;
-import org.expeditee.agents.SearchFramesetFast;
+import org.expeditee.agents.SearchTreeAndReplace;
 import org.expeditee.agents.SearchTree;
-import org.expeditee.agents.SearchTreeFast;
 import org.expeditee.agents.WriteTree;
 import org.expeditee.gui.AttributeUtils;
@@ -328,5 +328,11 @@
 			boolean acceptKeyboardInput, boolean step, int pause, Color color) {
 		try {
-			DisplayIO.addToBack(current.getParent());
+			if (current != null) {
+				DisplayIO.addToBack(current.getParent());
+			} else {
+				/*TODO we should not have to pass an item just to run a frame!*/
+				current = new Text("Dummy");
+				current.setLink(frame.getName());
+			}
 
 			_stepColor = color == null ? Color.green : color;
@@ -339,5 +345,5 @@
 
 			// an item without a link signals to run the current frame
-			if (current.getLink() == null) {
+			if (current != null && current.getLink() == null) {
 				// Make a copy but hide it
 				current = current.copy();
@@ -351,4 +357,5 @@
 			t.start();
 		} catch (Exception e) {
+			e.printStackTrace();
 		}
 	}
@@ -932,7 +939,8 @@
 				// The fast search does not do replacement
 				if (bReplace) {
+					searchAgent = new SearchFramesetAndReplace(firstFrame,
+							maxFrame, null);
+				} else {
 					searchAgent = new SearchFrameset(firstFrame, maxFrame, null);
-				} else {
-					searchAgent = new SearchFramesetFast(firstFrame, maxFrame, null);
 				}
 				searchAgent.initialise(null, null, frameset, resultsFrameset,
@@ -975,7 +983,7 @@
 				// now The fast search does not do replacement
 				if (bReplace) {
+					searchAgent = new SearchTreeAndReplace(null);
+				} else {
 					searchAgent = new SearchTree(null);
-				} else {
-					searchAgent = new SearchTreeFast(null);
 				}
 				_agent = searchAgent;
@@ -1675,5 +1683,5 @@
 			String s = getMessage(tokens, context, code.toString(), tokens[0]
 					.equals("type") ? " " : "", 1);
-			
+
 			DisplayIO.typeStringDirect(0.025, s);
 		} else if (tokens[0].equals("runstring")) {
@@ -2031,6 +2039,7 @@
 				} catch (Exception e) {
 				}
-			}else{
-				Frame zero = FrameIO.LoadFrame(freshCopy.getFramesetName() + "0");
+			} else {
+				Frame zero = FrameIO.LoadFrame(freshCopy.getFramesetName()
+						+ "0");
 				freshCopy.setPath(zero.getPath());
 			}
Index: /trunk/src/org/expeditee/actions/Spelling.java
===================================================================
--- /trunk/src/org/expeditee/actions/Spelling.java	(revision 376)
+++ /trunk/src/org/expeditee/actions/Spelling.java	(revision 376)
@@ -0,0 +1,81 @@
+package org.expeditee.actions;
+
+import java.io.BufferedReader;
+import java.io.FileNotFoundException;
+import java.io.FileReader;
+import java.io.IOException;
+import java.util.Collection;
+import java.util.LinkedList;
+
+import org.expeditee.agents.wordprocessing.JSpellChecker;
+import org.expeditee.gui.FrameIO;
+import org.expeditee.gui.MessageBay;
+import org.expeditee.gui.UserSettings;
+
+public class Spelling {
+	public static Collection<String> spellCheckFrame(String frameName,
+			String path) {
+		String fullPath = null;
+		JSpellChecker spellChecker = null;
+		try {
+			spellChecker = JSpellChecker.getInstance();
+		} catch (FileNotFoundException e1) {
+			e1.printStackTrace();
+			return null;
+		} catch (IOException e1) {
+			e1.printStackTrace();
+			return null;
+		}
+		if (path == null) {
+			for (String possiblePath : UserSettings.FrameDirs) {
+				fullPath = FrameIO
+						.getFrameFullPathName(possiblePath, frameName);
+				if (fullPath != null)
+					break;
+			}
+		} else {
+			fullPath = FrameIO.getFrameFullPathName(path, frameName);
+		}
+		// If the frame was not located return null
+		if (fullPath == null)
+			return null;
+		Collection<String> results = new LinkedList<String>();
+		// Open the file and search the text items
+		try {
+			BufferedReader reader = new BufferedReader(new FileReader(fullPath));
+			String next;
+			while (reader.ready() && ((next = reader.readLine()) != null)) {
+				if (next.startsWith("T")) {
+					String toSearch = next.substring(2);
+					spellChecker.setText(toSearch);
+					String misspelled = spellChecker.getMisspelledWord();
+					if (misspelled != null && misspelled.length() > 0) {
+						results.add(toSearch);
+					}
+				}
+			}
+		} catch (FileNotFoundException e) {
+			e.printStackTrace();
+			return null;
+		} catch (IOException e) {
+			e.printStackTrace();
+		}
+		return results;
+	}
+
+	public static String checkSpelling(String word) {
+		try {
+			return JSpellChecker.getInstance().getSuggestions(word);
+		} catch (FileNotFoundException e) {
+			MessageBay.errorMessage("Could not find dictionary: "
+					+ e.getMessage());
+		} catch (IOException e) {
+			e.printStackTrace();
+		}
+		return null;
+	}
+
+	public static String spellCheck(String word) {
+		return checkSpelling(word);
+	}
+}
Index: /trunk/src/org/expeditee/agents/DisplayGreenstoneSession.java
===================================================================
--- /trunk/src/org/expeditee/agents/DisplayGreenstoneSession.java	(revision 376)
+++ /trunk/src/org/expeditee/agents/DisplayGreenstoneSession.java	(revision 376)
@@ -0,0 +1,84 @@
+package org.expeditee.agents;
+
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.Comparator;
+import java.util.List;
+import java.util.Map;
+
+import org.expeditee.greenstone.ResultDocument;
+import org.expeditee.gui.FrameCreator;
+import org.expeditee.io.Logger;
+
+public class DisplayGreenstoneSession extends SearchGreenstone {
+
+	public DisplayGreenstoneSession(int resultsCount) {
+		super(resultsCount);
+	}
+
+	public DisplayGreenstoneSession() {
+		super();
+	}
+
+	protected void createResults() {
+		if (!_gsdl.getSessionResults().isEmpty()) {
+			viewSessionResults(_gsdl.getSessionResults(), _results);
+		}
+	}
+	
+	protected String getResultsTitle() {
+		return "SessionResults at " + Logger.EasyDateFormat(Logger.LONG_DATE_FORMAT);
+	}
+
+	/**
+	 * This method provides an alternative view of the result set It uses the
+	 * dateMap which organises results according to the year in which they were
+	 * published
+	 * 
+	 * You will need to write a similar method for any additional view that you
+	 * implement
+	 * 
+	 * You may wish to modify this method to provide a better layout of the
+	 * output
+	 */
+	private void viewSessionResults(Map<String, ResultDocument> sessionResults,
+			FrameCreator results) {
+
+		List<ResultDocument> resultDocArrayList = new ArrayList<ResultDocument>(
+				sessionResults.values());
+		Collections.sort(resultDocArrayList,
+				new DescendingSessionScoreComparator());
+
+		int docRank = 1;
+		
+		for(ResultDocument rd: resultDocArrayList){
+			addText(rd, results, docRank++ + ". " + rd.getTitle());
+		}
+
+	}
+	
+	protected String getCursorText() {
+		return getResultsTitle();
+	}
+
+	static class DescendingSessionScoreComparator implements Comparator<ResultDocument> {
+
+		public int compare(ResultDocument d1, ResultDocument d2) {
+
+			double sessionScore1 = d1.getSessionScore();
+			double sessionScore2 = d2.getSessionScore();
+
+			if (sessionScore1 > sessionScore2) {
+				return -1;
+			} else if (sessionScore1 < sessionScore2) {
+				return 1;
+			} else {
+				return 0;
+			}
+		}
+	}
+	
+	protected String getNoResultsMessage() {
+		return "The session results set is empty";
+	}
+}
Index: /trunk/src/org/expeditee/agents/Format.java
===================================================================
--- /trunk/src/org/expeditee/agents/Format.java	(revision 375)
+++ /trunk/src/org/expeditee/agents/Format.java	(revision 376)
@@ -5,4 +5,5 @@
 import java.util.Collections;
 import java.util.Comparator;
+import java.util.HashSet;
 import java.util.List;
 
@@ -45,12 +46,24 @@
 	@Override
 	public Frame process(Frame start) {
-		//TODO What will happen if user runs the SIMPLE form of this...
-		//Does format box need to be disabled?!?!
-		//Check the position of the cursor and only format stuff inside the same box as the cursor
+		// TODO What will happen if user runs the SIMPLE form of this...
+		// Does format box need to be disabled?!?!
+		// Check the position of the cursor and only format stuff inside the
+		// same box as the cursor
 		Collection<Text> itemsToFormat = FrameUtils.getCurrentTextItems();
-		if(itemsToFormat.size() < 1){
+
+		// If the cursor is not inside a box...
+		if (itemsToFormat.size() < 1) {
+			// Add all the items that are in free space
 			itemsToFormat = start.getBodyTextItems(true);
+			// Remove all the enclosed items
+			Collection<Item> seen = new HashSet<Item>();
+			for (Item i : start.getVisibleItems()) {
+				if (!seen.contains(i) && i.isEnclosed()) {
+					seen.addAll(i.getEnclosingDots());
+					itemsToFormat.removeAll(i.getEnclosedItems());
+				}
+			}
 		}
-		
+
 		ArrayList<Item> columnHeads = new ArrayList<Item>();
 
@@ -175,5 +188,5 @@
 			overwriteMessage("Formatting complete.");
 	}
-	
+
 	@Override
 	protected void message(String message) {
Index: /trunk/src/org/expeditee/agents/SearchAgent.java
===================================================================
--- /trunk/src/org/expeditee/agents/SearchAgent.java	(revision 375)
+++ /trunk/src/org/expeditee/agents/SearchAgent.java	(revision 376)
@@ -1,3 +1,5 @@
 package org.expeditee.agents;
+
+import java.util.Collection;
 
 import org.expeditee.gui.Frame;
@@ -24,5 +26,6 @@
 
 	public SearchAgent(String searchText) {
-		_pattern = searchText.toLowerCase();
+		if (searchText != null)
+			_pattern = searchText.toLowerCase();
 	}
 
@@ -39,6 +42,14 @@
 					false);
 		}
-		return initialise(frame, item, frame.getFramesetName(), resultFrameset,
+		return initialise(frame, item, getSearchDescription(frame), resultFrameset,
 				null, pattern);
+	}
+
+	/**
+	 * @param frame
+	 * @return
+	 */
+	protected String getSearchDescription(Frame frame) {
+		return frame.getFramesetName();
 	}
 
@@ -56,6 +67,7 @@
 	public boolean initialise(Frame frame, Item item, String startName,
 			String resultsFrameset, String replacementString, String pattern) {
-		//TODO: Put the init params in the constructor!! Dont want to be setting _pattern in two places!
-		
+		// TODO: Put the init params in the constructor!! Dont want to be
+		// setting _pattern in two places!
+
 		if (_pattern == null)
 			_pattern = pattern.toLowerCase();
@@ -66,10 +78,15 @@
 		// and type as the title
 		String title = this.getClass().getSimpleName() + " [" + startName
-				+ "] [" + _pattern + "]";
-		_results = new FrameCreator(resultsFrameset, FrameIO.FRAME_PATH, title, false, true);
+				+ "]"+getResultsTitleSuffix();
+		_results = new FrameCreator(resultsFrameset, FrameIO.FRAME_PATH, title,
+				false, true);
 		// Set the frame to be displayed after running the agent
 		_end = _results.getFirstFrame();
 
 		return super.initialise(frame, item);
+	}
+
+	protected String getResultsTitleSuffix() {
+		return " [" + _pattern + "]";
 	}
 
@@ -111,3 +128,39 @@
 		return true;
 	}
+	
+	protected int addResults(String frameName, Collection<String> found) {
+		return addResults(frameName, frameName, found);
+	}
+	
+	/**
+	 * @param frameNumber
+	 * @param frameName
+	 * @param found
+	 * @return
+	 */
+	protected int addResults(String frameNumber, String frameName, Collection<String> found) {
+		int size = found == null ? 0 : found.size();
+		// If the frame exists
+		if (found != null)
+			_frameCount++;
+		if (size > 0) {
+			// String repeats = size > 1? ("("+ size+ ")") : "";
+			for (String s : found) {
+				StringBuffer surrogate = new StringBuffer();
+				surrogate.append("[").append(frameNumber).append("] ");
+				if (s.length() > SearchAgent.SURROGATE_LENGTH)
+					surrogate.append(
+							s.substring(0, SearchAgent.SURROGATE_LENGTH - 3))
+							.append("...");
+				else {
+					surrogate.append(s);
+				}
+
+				_results.addText(surrogate.toString(), null,
+						frameName, null, false);
+				FrameGraphics.requestRefresh(true);
+			}
+		}
+		return size;
+	}
 }
Index: /trunk/src/org/expeditee/agents/SearchFrameset.java
===================================================================
--- /trunk/src/org/expeditee/agents/SearchFrameset.java	(revision 375)
+++ /trunk/src/org/expeditee/agents/SearchFrameset.java	(revision 376)
@@ -1,3 +1,5 @@
 package org.expeditee.agents;
+
+import java.util.Collection;
 
 import org.expeditee.gui.Frame;
@@ -6,6 +8,7 @@
 public class SearchFrameset extends SearchAgent {
 	private long _firstFrame = 1;
+
 	private long _maxFrame = Integer.MAX_VALUE;
-	
+
 	public SearchFrameset(long firstFrame, long maxFrame, String searchText) {
 		this(searchText);
@@ -13,5 +16,5 @@
 		_maxFrame = maxFrame;
 	}
-	
+
 	public SearchFrameset(String searchText) {
 		super(searchText);
@@ -20,6 +23,11 @@
 	@Override
 	protected Frame process(Frame frame) {
+		if (frame == null) {
+			frame = FrameIO.LoadFrame(_startName + '0');
+		}
+		String path = frame.getPath();
+
 		int count = FrameIO.getLastNumber(_startName);
-		for (long i = _firstFrame;i <= _maxFrame && i <= count; i++) {
+		for (long i = _firstFrame; i <= _maxFrame && i <= count; i++) {
 			if (_stop) {
 				break;
@@ -27,7 +35,7 @@
 			String frameName = _startName + i;
 			overwriteMessage("Searching " + frameName);
-			if(searchFrame(_results, frameName, _pattern,
-					_replacementString))
-				_frameCount++;
+			Collection<String> found = FrameIO.searchFrame(frameName, _pattern,
+					path);
+			addResults(i + "", frameName, found);
 		}
 		_results.save();
Index: /trunk/src/org/expeditee/agents/SearchFramesetAndReplace.java
===================================================================
--- /trunk/src/org/expeditee/agents/SearchFramesetAndReplace.java	(revision 376)
+++ /trunk/src/org/expeditee/agents/SearchFramesetAndReplace.java	(revision 376)
@@ -0,0 +1,41 @@
+package org.expeditee.agents;
+
+import org.expeditee.gui.Frame;
+import org.expeditee.gui.FrameIO;
+
+public class SearchFramesetAndReplace extends SearchAgent {
+	private long _firstFrame = 1;
+	private long _maxFrame = Integer.MAX_VALUE;
+	
+	public SearchFramesetAndReplace(long firstFrame, long maxFrame, String searchText) {
+		this(searchText);
+		_firstFrame = firstFrame;
+		_maxFrame = maxFrame;
+	}
+	
+	public SearchFramesetAndReplace(String searchText) {
+		super(searchText);
+	}
+
+	@Override
+	protected Frame process(Frame frame) {
+		int count = FrameIO.getLastNumber(_startName);
+		for (long i = _firstFrame;i <= _maxFrame && i <= count; i++) {
+			if (_stop) {
+				break;
+			}
+			String frameName = _startName + i;
+			overwriteMessage("Searching " + frameName);
+			if(searchFrame(_results, frameName, _pattern,
+					_replacementString))
+				_frameCount++;
+		}
+		_results.save();
+
+		String resultFrameName = _results.getName();
+		if (_clicked != null)
+			_clicked.setLink(resultFrameName);
+
+		return _results.getFirstFrame();
+	}
+}
Index: /trunk/src/org/expeditee/agents/SearchGreenstone.java
===================================================================
--- /trunk/src/org/expeditee/agents/SearchGreenstone.java	(revision 375)
+++ /trunk/src/org/expeditee/agents/SearchGreenstone.java	(revision 376)
@@ -1,5 +1,4 @@
 package org.expeditee.agents;
 
-import java.util.Enumeration;
 import java.util.HashMap;
 import java.util.Map;
@@ -30,4 +29,8 @@
 	protected static Greenstone3Connection _gsdl = null;
 
+	public static Greenstone3Connection getConnection() {
+		return _gsdl;
+	}
+
 	private static String _maxResults = "10";
 
@@ -84,4 +87,9 @@
 	}
 
+	public SearchGreenstone(int resultsCount) {
+		this(null);
+		_thisMaxResults = resultsCount + "";
+	}
+
 	public SearchGreenstone() {
 		super(null);
@@ -113,5 +121,4 @@
 			else if (attribute.equals("autoconnect"))
 				connect();
-
 			else if (attribute.equals("maxresults")) {
 				try {
@@ -119,7 +126,5 @@
 				} catch (Exception e) {
 				}
-			}
-
-			else if (attribute.equals("dostemming"))
+			} else if (attribute.equals("dostemming"))
 				_doStemming = true;
 			else if (attribute.startsWith("showabstract"))
@@ -139,8 +144,11 @@
 	}
 
+	protected String getResultsTitle() {
+		return this.getClass().getSimpleName() + "[" + getCursorText() + "]";
+	}
+
 	@Override
 	protected Frame process(Frame frame) {
-		String resultsTitle = this.getClass().getSimpleName() + "["
-				+ _fullCaseSearchQuery + "]";
+		String resultsTitle = getResultsTitle();
 		_results.setTitle(resultsTitle);
 
@@ -150,11 +158,11 @@
 		} else if (_currentResultSet != null) {
 			Text newText = DisplayIO.getCurrentFrame().createNewText(
-					_fullCaseSearchQuery);
+					getCursorText());
 			_clicked = newText;
 			FrameMouseActions.pickup(newText);
 		}
 
-		if (_currentResultSet == null) {
-			MessageBay.errorMessage("Could not find Greenstone query text");
+		if (_currentResultSet == null || _currentResultSet.size() == 0) {
+			MessageBay.errorMessage(getNoResultsMessage());
 			return null;
 		}
@@ -171,4 +179,15 @@
 
 		return _results.getFirstFrame();
+	}
+
+	protected String getNoResultsMessage() {
+		return "Could not find Greenstone query text";
+	}
+
+	/**
+	 * @return
+	 */
+	protected String getCursorText() {
+		return _fullCaseSearchQuery;
 	}
 
@@ -189,5 +208,6 @@
 		Query query = createQuery(queryText);
 		QueryOutcome queryOutcome = _gsdl.issueQueryToServer(query);
-		_currentResultSet = getResultSetMetadata(queryOutcome);
+		if (queryOutcome != null)
+			_currentResultSet = getResultSetMetadata(queryOutcome);
 	}
 
@@ -281,43 +301,41 @@
 
 		if (rd.metadataExists("Title")) {
-			resultText.append("title = " + rd.getTitle()).append('\n');
+			resultText.append("title: " + rd.getTitle()).append('\n');
 		}
 		if (rd.metadataExists("Date")) {
-			resultText.append("date = " + rd.getDate()).append('\n');
+			resultText.append("date: " + rd.getDate()).append('\n');
 		}
 		if (rd.metadataExists("Booktitle")) {
-			resultText.append("booktitle = " + rd.getBooktitle()).append('\n');
+			resultText.append("booktitle: " + rd.getBooktitle()).append('\n');
 		}
 		if (rd.metadataExists("Pages")) {
-			resultText.append("pages = " + rd.getPages()).append('\n');
+			resultText.append("pages: " + rd.getPages()).append('\n');
 		}
 		if (rd.metadataExists("Journal")) {
-			resultText.append("journal = " + rd.getJournal()).append('\n');
+			resultText.append("journal: " + rd.getJournal()).append('\n');
 		}
 		if (rd.metadataExists("Volume")) {
-			resultText.append("volume = " + rd.getVolume()).append('\n');
+			resultText.append("volume: " + rd.getVolume()).append('\n');
 		}
 		if (rd.metadataExists("Number")) {
-			resultText.append("number = " + rd.getNumber()).append('\n');
+			resultText.append("number: " + rd.getNumber()).append('\n');
 		}
 		if (rd.metadataExists("Editor")) {
-			resultText.append("editor = " + rd.getEditor()).append('\n');
+			resultText.append("editor: " + rd.getEditor()).append('\n');
 		}
 		if (rd.metadataExists("Publisher")) {
-			resultText.append("publisher = " + rd.getPublisher()).append('\n');
+			resultText.append("publisher: " + rd.getPublisher()).append('\n');
 		}
 		if (rd.metadataExists("Abstract")) {
-			resultText.append("abstract = " + rd.getAbstract()).append('\n');
-		}
-		Vector<String> authors = rd.getAuthors();
-		for (Enumeration a = authors.elements(); a.hasMoreElements();) {
-			String author = (String) a.nextElement();
-			resultText.append("author = " + author).append('\n');
-		}
-		Vector<String> keywords = rd.getKeywords();
-		for (Enumeration k = keywords.elements(); k.hasMoreElements();) {
-			String keyword = (String) k.nextElement();
-			resultText.append("keyword = " + keyword).append('\n');
-		}
+			resultText.append("abstract: " + rd.getAbstract()).append('\n');
+		}
+		for (String author : rd.getAuthors()) {
+			resultText.append("author: " + author).append('\n');
+		}
+
+		for (String keyword : rd.getKeywords()) {
+			resultText.append("keyword: " + keyword).append('\n');
+		}
+
 		resultText.deleteCharAt(resultText.length() - 1);
 
@@ -356,3 +374,8 @@
 	}
 
+	public static void clearSession() {
+		getConnection().getSessionResults().clear();
+		_currentResultSet = null;
+	}
+
 }
